var FitSMS_Link_mpcnet = "http://www.mpcnet.de";
var FitSMS_Link_Home = "http://www.fitsms.de/deeplink/firefox-extension";
var FitSMS_Link_SendSMS = "https://www.fitsms.de/Firefox-Extension-Send.do";
var FitSMS_Link_Feedback = "https://www.fitsms.de/Firefox-Extension-Feedback.do";

var prefManager = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
var knownCountryPrefixes = Array("49", "43", "41");

function FitSMS_Logo(event) {
	
	FitSMS_LoadURLNewTab(FitSMS_Link_Home);
	
}

function FitSMS_AddressBook(event) {
	
	window.openDialog("chrome://fitsms/content/addressbook.xul", "FitSMS_AddressBook", "chrome,titlebar,toolbar,centerscreen,modal");
	
}

function FitSMS_Preferences(event) {
	
	window.openDialog("chrome://fitsms/content/options.xul", "FitSMS_Preferences", "chrome,titlebar,toolbar,centerscreen,modal");
	
}

function FitSMS_Feedback(event) {
	
	FitSMS_LoadURLNewTab(FitSMS_Link_Feedback);
	
}

function FitSMS_KeyHandler(event) {
	
	if (event.keyCode == event.DOM_VK_RETURN) {
		FitSMS_SendSMS(event);
	}
	
}

function FitSMS_ParseRecipients(event) {
	
	var formFieldRecipients = document.getElementById("FitSMS-Recipients");
	
	var nummer = FitSMS_TrimString(formFieldRecipients.value);
	if ( (nummer.length > 0) && (nummer.indexOf(",") == -1) ) {
		nummer = FitSMS_FormatMobileNumber(nummer);
		if (nummer.length == 0) {
			alert("Die von Ihnen eingegebene Mobilfunk-Nummer ist ungültig.");
		} else {
			formFieldRecipients.value = nummer;
		}
	}
	
}

function FitSMS_FormatMobileNumber(nummer) {
	
	nummer = nummer.replace(/[^0-9]+/g, "");
	if (nummer.length > 2) {
		if (nummer.substring(0,2) == "01") {
			nummer = "49"+nummer.substring(1,nummer.length);
		} else if (nummer.substring(0,2) == "00") {
			nummer = nummer.substring(2,nummer.length);
		} else if (nummer.substring(0,1) == "0") {
			nummer = nummer.substring(1,nummer.length);
		}
		var hasKnownPrefix = false;
		var k = 0;
		for (k=0; k < knownCountryPrefixes.length; k++) {
			var prefix = knownCountryPrefixes[k];
			if (nummer.substring(0,prefix.length) == prefix) {
				hasKnownPrefix = true;
				break;
			}
		}
		if (hasKnownPrefix) {
			nummer = "00"+nummer;
		} else {
			nummer = "0049"+nummer;
		}
		return nummer;
	} else {
		return "";
	}	
	
}

function FitSMS_ContentCount(event) {
	
	var formFieldContent = document.getElementById("FitSMS-Content");
	var labelContentCount = document.getElementById("FitSMS-ContentCount-Label");
	
	var contentCount = formFieldContent.value.length;
	// double-count special characters; € = euro-sign
	contentCount += formFieldContent.value.replace(/[^€,|,\^,{,},\[,\],\\,\~]+/g, "").length;
	var contentCountSMS = Math.ceil(contentCount/160);
	var contentCountPrefix = "";
	if ( contentCount < 10 ) {
		contentCountPrefix = "00";
	} else if ( contentCount < 100 ) {
		contentCountPrefix = "0";
	}
	labelContentCount.value = contentCountPrefix+contentCount+ " Zeichen ("+contentCountSMS+" SMS)";
		
}

function FitSMS_SendSMS(event) {
	
	var formFieldRecipients = document.getElementById("FitSMS-Recipients");
	var formFieldContent = document.getElementById("FitSMS-Content");
	
	var url = FitSMS_Link_SendSMS+"?recipients="+encodeURIComponent(formFieldRecipients.value)+"&content="+encodeURIComponent(formFieldContent.value)+"&sender="+encodeURIComponent(prefManager.getCharPref("extensions.fitsms.sender"));
	if ( prefManager.getBoolPref("extensions.fitsms.sendsmsinnewtab") ) {
		FitSMS_LoadURLNewTab(url);		
	} else {	
		FitSMS_LoadURL(url);
	}
	
}

function FitSMS_TrimString(string) {
	
    if (!string) {
        return "";
    }
    string = string.replace(/^\s+/, ''); // Remove leading whitespace
    string = string.replace(/\s+$/, ''); // Remove trailing whitespace    
    return string;
    
}

function FitSMS_LoadURL(url) {
	
	window.content.document.location = url;
	window.content.focus();
	
}

function FitSMS_LoadURLNewTab(url) {
	
	try {
		var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator);
		navWindow = wm.getMostRecentWindow("navigator:browser");
		navWindow.delayedOpenTab(url);
	} catch(ex) {
		//
	}
	
}
